﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.IO;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;


/// <summary> 
/// 迷你音乐播放器
/// <author> 
///     <name>漓江烟雨</name> 
///     <QQ>648445213</QQ>
///     <date>2011.12.3</date> 
/// </author> 
/// </summary> 


namespace MiniMusicPlayer
{
    public partial class MiniMusicPlayer : Form
    {
        string ShutDownTime = ""; //定时关机时间
        int FormPositioX; //记录当前窗口坐标
        int FormPositioY;
        string changeBackPath = "black\\";
        string playImage_on = "play_on.png";
        string playImage_down = "play_down.png";
        int UCcurrenttime = 16; //自定义用户控件初始值
        private static string PathBase = Application.StartupPath; //获取应用程序启动路径
        string xmlfile = PathBase + "\\PlayerList.xml"; //XML音乐列表文件

        [DllImport("user32.dll", EntryPoint = "GetWindowLong", CharSet = CharSet.Auto)] //管理FormBorderStyle：none
        public static extern int GetWindowLong(HandleRef hWnd, int nIndex);             //点击任务栏最大化最小化程序
        [DllImport("user32.dll", EntryPoint = "SetWindowLong", CharSet = CharSet.Auto)]
        public static extern IntPtr SetWindowLong(HandleRef hWnd, int nIndex, int dwNewLong);

        public MiniMusicPlayer()
        {
            InitializeComponent();
            timer1.Stop();
            axWMusicPlayer.currentPlaylist = axWMusicPlayer.newPlaylist("MusicPlayList", ""); //初始化播放器播放列表
            SetpicBoxConver();
            IsCreateXmlFile();
            FillCurrenrList();
            axWMusicPlayer.settings.volume = 70; //接受键盘按键
        }

        private void MiniMusicPlayer_Load(object sender, EventArgs e)
        {
            //点击任务栏图标实现最大化最小化
            int WS_SYSMENU = 0x00080000; // 系统菜单
            int WS_MINIMIZEBOX = 0x20000; // 最大最小化按钮
            int windowLong = (GetWindowLong(new HandleRef(this, this.Handle), -16));
            SetWindowLong(new HandleRef(this, this.Handle), -16, windowLong | WS_SYSMENU | WS_MINIMIZEBOX);

            //处理开启多个程序，检测进程，只允许一个应用程序运行
            string mName = Process.GetCurrentProcess().MainModule.ModuleName;
            string pName = Path.GetFileNameWithoutExtension(mName);
            Process[] pro = Process.GetProcessesByName(pName);
            if (pro.Length > 1)
            {
                //MessageBox.Show("程序已经在运行，无需重复运行。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Dispose();
                Application.ExitThread();
            }
        }

        protected override void OnResize(EventArgs e)
        {
            borderStyle border = new borderStyle(this.Width, this.Height, 0);
            this.Region = new Region(border.graPath);
        }

        private void axWMusicPlayer_ErrorEvent(object sender, EventArgs e)
        {
            throw new Exception("读取歌曲错误，请重试！");
        }

        private void axWMusicPlayer_PlayStateChange(object sender, AxWMPLib._WMPOCXEvents_PlayStateChangeEvent e)
        {
            if (axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsMediaEnded || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsStopped || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsReady || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsReady || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsWaiting)
            {
                lblcurrenttime.Text = "00:00 / 00:00";
            }
            //lbltotaltime.Text = axWMusicPlayer.currentMedia.durationString;
            //axWMusicPlayer.currentMedia.getItemInfo("Author"); //艺术家
            //getItemInfo参数                        //Title 媒体标题
                                                     //Duration 持续时间
                                                     //Copyright 版权信息
                                                     //Description 媒体内容描述
                                                     //FileSize 文件大小
                                                     //FileType 文件类型
                                                     //sourceURL 原始地址
            //axWindowsMediaPlayer1.settings.rate;//播放速率,一般乘以16后再显示kbps单位
            //axWindowsMediaPlayer1.currentMedia.setItemInfo("Title", "被风吹过的夏天");
            
        }

        string middlestring; //歌曲名与歌手之间的线条
        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                if (axWMusicPlayer.currentMedia != null)
                {
                    if (axWMusicPlayer.currentMedia.name.Length > 9) //显示歌曲名称
                    {
                        lblMusicName.Text = axWMusicPlayer.currentMedia.name.Substring(0, 9) + "...";
                    }
                    else
                    {
                        lblMusicName.Text = axWMusicPlayer.currentMedia.name;
                    }

                    if (axWMusicPlayer.currentMedia.getItemInfo("Author") == "") //托盘图标文字
                    {
                        middlestring = "";
                    }
                    else
                    {
                        middlestring = "---";
                    }
                    MynotifyIcon.Text = axWMusicPlayer.currentMedia.name + middlestring + axWMusicPlayer.currentMedia.getItemInfo("Author");

                    lblcurrenttime.Text = axWMusicPlayer.Ctlcontrols.currentPositionString + " / " + axWMusicPlayer.currentMedia.durationString;
                    UCcurrenttime = Convert.ToInt32(axWMusicPlayer.Ctlcontrols.currentPosition / axWMusicPlayer.currentMedia.duration * 170);
                    if (UCcurrenttime <= 16)
                    {
                        UCcurrenttime = 16;
                    }
                    this.userControl11.Width = UCcurrenttime;
                }
            }
            catch
            {
                return;
            }
        }

        private void btnPlay_Click(object sender, EventArgs e)
        {
            PlayControl();
        }

        /// <summary>
        /// 控制播放暂停
        /// </summary>
        private void PlayControl()
        {
            if (axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsPaused || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsStopped || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsReady || axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsTransitioning) //播放
            {
                axWMusicPlayer.Ctlcontrols.play();
                timer1.Start();
                playImage_on = "pause_on.png";
                playImage_down = "pause_down.png";
                this.btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_on);
                暂停SToolStripMenuItem.Enabled = true;
                播放PToolStripMenuItem.Enabled = false;
                播放PToolStripMenuItem.Checked = true;
                暂停SToolStripMenuItem.Checked = false;
            }
            else if (axWMusicPlayer.playState == WMPLib.WMPPlayState.wmppsPlaying) //暂停
            {
                axWMusicPlayer.Ctlcontrols.pause();
                timer1.Stop();
                playImage_on = "play_on.png";
                playImage_down = "play_down.png";
                this.btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_on);
                暂停SToolStripMenuItem.Enabled = false;
                播放PToolStripMenuItem.Enabled = true;
                暂停SToolStripMenuItem.Checked = true;
                播放PToolStripMenuItem.Checked = false;

            }
            else
            {
                MessageBox.Show("当前播放列表无歌曲，请点击添加按钮添加歌曲。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }
        }

        #region 按钮点击效果
        //播放按钮
        private void btnPlay_MouseEnter(object sender, EventArgs e)
        {
            btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_down);
        }

        private void btnPlay_MouseDown(object sender, MouseEventArgs e)
        {
            btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_on);
        }

        private void btnPlay_MouseLeave(object sender, EventArgs e)
        {
            btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_on);
        }

        private void btnPlay_MouseUp(object sender, MouseEventArgs e)
        {
            btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_down);
        }

        //上一曲按钮
        private void btnPreview_MouseEnter(object sender, EventArgs e)
        {
            btnPreview.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "preview_down.png");
        }

        private void btnPreview_MouseDown(object sender, MouseEventArgs e)
        {
            btnPreview.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "preview_on.png");
        }

        private void btnPreview_MouseLeave(object sender, EventArgs e)
        {
            btnPreview.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "preview_on.png");
        }

        private void btnPreview_MouseUp(object sender, MouseEventArgs e)
        {
            btnPreview.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "preview_down.png");
        }

        //下一曲按钮
        private void btnNext_MouseEnter(object sender, EventArgs e)
        {
            btnNext.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "next_down.png");
        }

        private void btnNext_MouseDown(object sender, MouseEventArgs e)
        {
            btnNext.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "next_on.png");
        }

        private void btnNext_MouseLeave(object sender, EventArgs e)
        {
            btnNext.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "next_on.png");
        }

        private void btnNext_MouseUp(object sender, MouseEventArgs e)
        {
            btnNext.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "next_down.png");
        }

        //喜爱按钮
        private void btnFavorite_MouseDown(object sender, MouseEventArgs e)
        {
            btnFavorite.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "favorite_on.png");
        }

        private void btnFavorite_MouseEnter(object sender, EventArgs e)
        {
            btnFavorite.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "favorite_down.png");
        }

        private void btnFavorite_MouseLeave(object sender, EventArgs e)
        {
            btnFavorite.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "favorite_on.png");
        }

        private void btnFavorite_MouseUp(object sender, MouseEventArgs e)
        {
            btnFavorite.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "favorite_down.png");
        }

        //列表按钮
        private void btnList_MouseDown(object sender, MouseEventArgs e)
        {
            btnList.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "list_on.png");
        }

        private void btnList_MouseEnter(object sender, EventArgs e)
        {
            btnList.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "list_down.png");
        }

        private void btnList_MouseLeave(object sender, EventArgs e)
        {
            btnList.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "list_on.png");
        }

        private void btnList_MouseUp(object sender, MouseEventArgs e)
        {
            btnList.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "list_down.png");
        }
        #endregion

        private void MiniMusicPlayer_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason == CloseReason.ApplicationExitCall || e.CloseReason == CloseReason.UserClosing) //截获退出应用程序事件，弹出对话框
            {
                if (MessageBox.Show("确定退出迷你音乐播放器吗？", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    e.Cancel = false;
                }
                else
                {
                    e.Cancel = true;
                }
            }
        }

        private void MiniMusicPlayer_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                FormPositioX = e.X;
                FormPositioY = e.Y;
            }
        }

        private void MiniMusicPlayer_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                this.Left += e.X - FormPositioX;
                this.Top += e.Y - FormPositioY;
            }
        }

        private void MiniMusicPlayer_MouseUp(object sender, MouseEventArgs e)
        {
            if (this.Left <= 0)
            {
                this.Left = 0;
            }
            if (this.Top <= 0)
            {
                this.Top = 0;
            }

            int ScreenEidth = Screen.GetWorkingArea(this).Width; //获得屏幕的宽
            int ScreenGeight = Screen.GetWorkingArea(this).Height; //获得屏幕的高
            if (this.Left + this.Width >= ScreenEidth)
            {
                this.Left = ScreenEidth - this.Width;
            }
            if (this.Top + this.Height >= ScreenGeight)
            {
                this.Top = ScreenGeight - this.Height;
            }
        }

        private void MiniMusicPlayer_KeyDown(object sender, KeyEventArgs e) //组合键调节音量、上下曲
        {
            if ((e.Control) && (e.Alt) && (e.KeyCode == Keys.Up)) //加音量
            {
                if (axWMusicPlayer.settings.volume >= 100)
                {
                    axWMusicPlayer.settings.volume = 100;
                }
                else
                {
                    axWMusicPlayer.settings.volume += 5;
                }
            }
            if (e.Control && e.Alt && (e.KeyCode == Keys.Down)) //减音量
            {
                if (axWMusicPlayer.settings.volume <= 0)
                {
                    axWMusicPlayer.settings.volume = 0;
                }
                else
                {
                    axWMusicPlayer.settings.volume -= 5;
                }
            }
            if (e.Control && e.Alt && (e.KeyCode == Keys.Left)) //上一曲
            {
                axWMusicPlayer.Ctlcontrols.previous();
            }
            if (e.Control && e.Alt && (e.KeyCode == Keys.Right)) //下一曲
            {
                axWMusicPlayer.Ctlcontrols.next();
            }
        }

        bool arg = true;
        private void MynotifyIcon_DoubleClick(object sender, EventArgs e)
        {
            if (arg)
            {
                arg = false;
                显示主窗口DToolStripMenuItem.Visible = true;
                隐藏主窗口HToolStripMenuItem.Visible = false;
                this.Visible = false;
            }
            else
            {
                arg = true;
                隐藏主窗口HToolStripMenuItem.Visible = true;
                显示主窗口DToolStripMenuItem.Visible = false;
                this.Visible = true;
            }
        }

        private void 显示主窗口DToolStripMenuItem_Click(object sender, EventArgs e)
        {
            显示主窗口DToolStripMenuItem.Visible = false;
            隐藏主窗口HToolStripMenuItem.Visible = true;
            this.Visible = true;
            arg = true;
        }

        private void 隐藏主窗口HToolStripMenuItem_Click(object sender, EventArgs e)
        {
            隐藏主窗口HToolStripMenuItem.Visible = false;
            显示主窗口DToolStripMenuItem.Visible = true;
            this.Visible = false;
            arg = false;
        }

        private void 单曲循环ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axWMusicPlayer.settings.setMode("shuffle", false);
            单曲循环ToolStripMenuItem.Checked = true;
            全部循环ToolStripMenuItem.Checked = false;
            顺序播放ToolStripMenuItem.Checked = false;
            随机播放RToolStripMenuItem.Checked = false;
        }

        private void 全部循环ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axWMusicPlayer.settings.setMode("loop", true);
            单曲循环ToolStripMenuItem.Checked = false;
            全部循环ToolStripMenuItem.Checked = true;
            顺序播放ToolStripMenuItem.Checked = false;
            随机播放RToolStripMenuItem.Checked = false;
        }

        private void 顺序播放ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axWMusicPlayer.settings.setMode("shuffle", false);
            单曲循环ToolStripMenuItem.Checked = false;
            全部循环ToolStripMenuItem.Checked = false;
            顺序播放ToolStripMenuItem.Checked = true;
            随机播放RToolStripMenuItem.Checked = false;
        }

        private void 随机播放RToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axWMusicPlayer.settings.setMode("shuffle", true);
            单曲循环ToolStripMenuItem.Checked = false;
            全部循环ToolStripMenuItem.Checked = false;
            顺序播放ToolStripMenuItem.Checked = false;
            随机播放RToolStripMenuItem.Checked = true;
        }

        private void 帮助HToolStripMenuItem_Click(object sender, EventArgs e)
        {
            帮助HToolStripMenuItem.Enabled = false;
            HelpForm help = new HelpForm();
            if (help.ShowDialog() == DialogResult.OK)
            {
                帮助HToolStripMenuItem.Enabled = true;
            }
            
        }

        private void 退出EToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void 定时关机SToolStripMenuItem_Click(object sender, EventArgs e)
        {
            关机时间toolStripTextBox.Text = DateTime.Now.ToLongTimeString();
            关机时间toolStripTextBox.Visible = true;
        }

        private void 关机时间toolStripTextBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter && 关机时间toolStripTextBox.Text != "")
            {
                try
                {
                    DateTime time = DateTime.Parse(关机时间toolStripTextBox.Text);
                    TimeSpan span = new TimeSpan(time.Hour, time.Minute, 0);
                    if (span.CompareTo(new TimeSpan(DateTime.Now.Hour, DateTime.Now.Minute, 0)) == 0) //当前关机时间
                    {
                        if (MessageBox.Show("你设定的关机时间是当前计算机时间，是否直接关机？", "提示", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.OK)
                        {
                            MynotifyIcon.Icon = Icon.ExtractAssociatedIcon(PathBase + "\\Images\\" + "ShutDown_notifyIcon.ico");
                            //
                            //调用关机程序
                            //
                        }
                        else
                        {
                            return;
                        }
                    }
                    if (span.CompareTo(new TimeSpan(DateTime.Now.Hour, DateTime.Now.Minute, 0)) < 0) //过去关机时间
                    {
                        MessageBox.Show("此时间已是过去时间，设定无效", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        return;
                    }
                    if (span.CompareTo(new TimeSpan(DateTime.Now.Hour, DateTime.Now.Minute, 0)) > 0) //有效关机时间
                    {

                        ShutDownTime = 关机时间toolStripTextBox.Text;
                        MessageBox.Show("成功设置定时关机，计算机将于“" + ShutDownTime + "”关机…… *︶︵︶*", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        this.关机时间toolStripTextBox.Visible = false;
                        this.取消定时关机QToolStripMenuItem.Visible = true;

                        //
                        //调用关机程序
                        //
                    }
                }
                catch
                {
                    MessageBox.Show("日期格式不正确，请重新输入。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }
            }
            if (e.KeyChar == (char)Keys.Enter && 关机时间toolStripTextBox.Text == "")
            {
                关机时间toolStripTextBox.Visible = false;
            }
        }

        private void 取消定时关机QToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ShutDownTime = "";
            MynotifyIcon.Icon = Icon.ExtractAssociatedIcon(PathBase + "\\Images\\" + "notifyIcon.ico");
            this.取消定时关机QToolStripMenuItem.Visible = false;
            this.关机时间toolStripTextBox.Visible = false;
        }

        private void lblMusicName_MouseMove(object sender, MouseEventArgs e)
        {
            if (axWMusicPlayer.currentMedia != null)
            {
                toolTip1.SetToolTip(lblMusicName, axWMusicPlayer.currentMedia.name);
            }
        }

        private void btnList_Click(object sender, EventArgs e) //添加歌曲
        {
            openFileDialog1.Title = "添加歌曲";
            openFileDialog1.FileName = "";
            openFileDialog1.Multiselect = true;
            openFileDialog1.Filter = "Mp3文件|*.mp3|Wav文件|*.wav|Wma文件|*.wma|Wmv文件|*.wmv|所有格式|*.*";
            openFileDialog1.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyMusic);
            try
            {
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    //IsCreateXmlFile();
                    XmlDocument xmldoc = new XmlDocument();
                    xmldoc.Load(xmlfile);
                    XmlNode root = xmldoc.SelectSingleNode("MusicList");
                    string[] FileNamesList = openFileDialog1.FileNames;
                    foreach (string file in FileNamesList)
                    {
                        string filename= Path.GetFileName(file).Substring(0,Path.GetFileName(file).LastIndexOf('.'));
                        axWMusicPlayer.currentPlaylist.appendItem(axWMusicPlayer.newMedia(file));
                        XmlElement newelement = xmldoc.CreateElement("MusicProperty");
                        newelement.SetAttribute("MusicUrl", file);
                        newelement.SetAttribute("MusicName", filename);
                        newelement.SetAttribute("LikeCount", "0");
                        root.AppendChild(newelement);
                        Application.DoEvents();
                    }
                    xmldoc.Save(xmlfile);
                    FileNamesList = null;
                }
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message, "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        /// <summary>
        /// 初始化音乐播放列表 如果没有则创建
        /// </summary>
        protected void IsCreateXmlFile()
        {
            try
            {
                if (!File.Exists(xmlfile))
                {
                    //File.Create(xmlfile);
                    FileStream stream = new FileStream(xmlfile, FileMode.OpenOrCreate, FileAccess.Write);
                    stream.Dispose(); //释放以XmlDocument写入
                    XmlDocument doc = new XmlDocument();
                    XmlNode DeclarationNode = doc.CreateXmlDeclaration("1.0", "utf-8", "");
                    doc.AppendChild(DeclarationNode);
                    XmlNode CommentNode = doc.CreateComment("迷你音乐播放器播放列表");
                    doc.AppendChild(CommentNode);
                    XmlElement ElementNode = doc.CreateElement("MusicList");
                    doc.AppendChild(ElementNode);
                    doc.Save(xmlfile);
                }
                
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message, "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        /// <summary>
        /// 随机设置专辑封面图片
        /// </summary>
        protected void SetpicBoxConver()
        {
            Random ram = new Random();
            int num = ram.Next(1, 11);
            picBoxConver.Image = Image.FromFile(PathBase + "\\Images\\Ambupicture" + num.ToString() + ".png");

            if (!File.Exists(PathBase + "\\Images\\Ambupicture" + num.ToString() + ".png")) //没找到则采用默认的
            {
                picBoxConver.Image = Image.FromFile(PathBase + "\\Images\\Ambupicture3.png");
            }
        }

        /// <summary>
        ///  填充播放列表
        /// </summary>
        protected void FillCurrenrList()
        {
            XmlDocument doc = new XmlDocument();
            doc.Load(xmlfile);
            if (doc.SelectSingleNode("MusicList").ChildNodes.Count != 0)
            {
                XmlNodeList NodeList = doc.SelectSingleNode("MusicList").ChildNodes;
                string[] musiclist = new string[doc.SelectSingleNode("MusicList").ChildNodes.Count]; //每条MusicProperty组成一维数组
                int num = 0;
                foreach (XmlNode node in NodeList)
                {
                    XmlElement element = (XmlElement)node;
                    musiclist[num] = element.GetAttribute("MusicUrl") + ";" + element.GetAttribute("LikeCount");
                    num++;
                }
                
                string[,] musiclist2 = new string[num, 2]; //将一维数组分割为二维数组：MusicUrl、LikeCount
                for (int i = 0; i < num; i++)
                {
                    string[] hh = musiclist[i].Split(';');
                    musiclist2[i, 0] = hh[0];
                    musiclist2[i, 1] = hh[1];
                }
                musiclist = null;
                string temp;
                for (int i = 0; i < num - 1; i++) //按点击次数冒泡排序，排序后的数组添加到axWMusicPlayer.currentPlaylist
                {
                    for (int j = 0; j < num - 1 - i; j++)
                    {
                        if (Convert.ToInt32(musiclist2[j, 1]) < Convert.ToInt32(musiclist2[j + 1, 1]))
                        {
                            temp = musiclist2[j, 1];
                            musiclist2[j, 1] = musiclist2[j + 1, 1];
                            musiclist2[j + 1, 1] = temp;

                            temp = musiclist2[j, 0];
                            musiclist2[j, 0] = musiclist2[j + 1, 0];
                            musiclist2[j + 1, 0] = temp;
                        }
                    }
                }

                for (int i = 0; i < num; i++) //填充播放列表
                {
                    axWMusicPlayer.currentPlaylist.appendItem(axWMusicPlayer.newMedia(musiclist2[i, 0]));
                }
                musiclist2 = null;
            }
        }

        private void btnPreview_Click(object sender, EventArgs e) //上一曲
        {
            axWMusicPlayer.Ctlcontrols.previous();

        }

        private void btnNext_Click(object sender, EventArgs e) //下一曲
        {
            axWMusicPlayer.Ctlcontrols.next();
        }

        private void btnFavorite_Click(object sender, EventArgs e) //喜爱
        {
            if (axWMusicPlayer.currentMedia != null)
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(xmlfile);
                XmlNodeList nodelist = doc.SelectSingleNode("MusicList").ChildNodes;
                foreach (XmlNode node in nodelist)
                {
                    XmlElement element = (XmlElement)node; //将XmlNode节点node转化成XmlElement型的node
                    if (element.GetAttribute("MusicUrl") == axWMusicPlayer.currentMedia.sourceURL)
                    {
                        int likecount = Convert.ToInt32(element.GetAttribute("LikeCount")) + 1;
                        element.SetAttribute("LikeCount", likecount.ToString());
                    }
                }
                doc.Save(xmlfile);
            }
        }

        private void pictureBox2_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                axWMusicPlayer.Ctlcontrols.currentPosition = e.X * axWMusicPlayer.currentMedia.duration / 170;
            }
        }

        private void userControl11_MouseDown(object sender, MouseEventArgs e) //？？点击当前进度条，程序执行不到此
        {
            axWMusicPlayer.Ctlcontrols.currentPosition = e.X * axWMusicPlayer.currentMedia.duration / 170;
        }

        private void 上一曲UToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axWMusicPlayer.Ctlcontrols.previous();
        }

        private void 下一曲NToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axWMusicPlayer.Ctlcontrols.next();
        }

        private void 播放PToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PlayControl();
        }

        private void 暂停SToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PlayControl();
        }

        private void 默认DToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages.png");
            changeBackPath = "black\\";
            SetBtnBlackBtn();
            SetItemCheck(true, false, false, false, false, false, false);
            //lblcurrenttime.ForeColor = Color.Peru;
        }

        private void 木质WToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages1.png");
            changeBackPath = "white\\";
            SetBtnWhite();
            SetItemCheck(false, true, false, false, false, false, false);
            //lblcurrenttime.ForeColor = Color.LawnGreen;
        }

        private void 天空TToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages2.png");
            changeBackPath = "white\\";
            SetBtnWhite();
            SetItemCheck(false, false, true, false, false, false, false);
            //lblcurrenttime.ForeColor = Color.LawnGreen;
        }

        private void 纹理LToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages3.png");
            changeBackPath = "white\\";
            SetBtnWhite();
            SetItemCheck(false, false, false, true, false, false, false);
            //lblcurrenttime.ForeColor = Color.LawnGreen;
        }

        private void 宇宙EToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages4.png");
            changeBackPath = "white\\";
            SetBtnWhite();
            SetItemCheck(false, false, false, false, true, false, false);
            //lblcurrenttime.ForeColor = Color.LawnGreen;
        }

        private void 梦幻BToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages5.png");
            changeBackPath = "white\\";
            SetBtnWhite();
            SetItemCheck(false, false, false, false, false, true, false);
        }

        private void 抽象AToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + "ALLbackimages6.png");
            changeBackPath = "white\\";
            SetBtnWhite();
            SetItemCheck(false, false, false, false, false, false, true);
        }
        
        private void MiniMusicPlayer_KeyUp(object sender, KeyEventArgs e) //？？？为什么会执行两遍
        {
            if (e.KeyCode == Keys.Space)
            {
                PlayControl();
            }
        }

        /// <summary>
        /// 设置为白色按钮
        /// </summary>
        private void SetBtnWhite()
        {
            this.btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_on);
            this.btnPreview.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "preview_on.png");
            this.btnNext.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "next_on.png");
            this.btnFavorite.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "favorite_on.png");
            this.btnList.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "list_on.png");
        }

        /// <summary>
        /// 设置为黑色按钮
        /// </summary>
        private void SetBtnBlackBtn()
        {
            this.btnPlay.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + playImage_on);
            this.btnPreview.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "preview_on.png");
            this.btnNext.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "next_on.png");
            this.btnFavorite.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "favorite_on.png");
            this.btnList.BackgroundImage = Image.FromFile(PathBase + "\\Images\\" + changeBackPath + "list_on.png");
        }

        /// <summary>
        /// 设置选中皮肤选项Item
        /// </summary>
        /// <param name="def">指示默认项项是否选中</param>
        /// <param name="wood">指示木质项项是否选中</param>
        /// <param name="sky">指示天空项项是否选中</param>
        /// <param name="slid">指示纹理项项是否选中</param>
        /// <param name="et">指示宇宙项项是否选中</param>
        /// <param name="blue">指示蓝天项项是否选中</param>
        private void SetItemCheck(bool def, bool wood, bool sky, bool slid, bool et, bool blue, bool abs)
        {
            默认DToolStripMenuItem.Checked = def;
            木质WToolStripMenuItem.Checked = wood;
            天空TToolStripMenuItem.Checked = sky;
            纹理LToolStripMenuItem.Checked = slid;
            宇宙EToolStripMenuItem.Checked = et;
            梦幻BToolStripMenuItem.Checked = blue;
            抽象AToolStripMenuItem.Checked = abs;
        }

        
    }
}
