﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;


/// <summary> 
/// 迷你音乐播放器
/// <author> 
///     <name>漓江烟雨</name> 
///     <QQ>648445213</QQ>
///     <date>2011.12.3</date> 
/// </author> 
/// </summary> 


namespace UCCurrentTime
{
    public partial class UserControl1 : UserControl
    {
        /// <summary>
        /// 设置或获取当前播放进度条的宽度
        /// </summary>
        public int UCTime
        {
            get { return this.Width; }
            set 
            {
                if (this.Width >= 16)
                {
                    this.Width = value;
                }
                else
                {
                    this.Width = value + 16;
                }
                
            }
        }

        /// <summary>
        /// 设置或获取当前播放进度条左边背景图片
        /// </summary>
        public Image LeftBackImage
        {
            get { return picBoxLeft.BackgroundImage; }
            set { picBoxLeft.BackgroundImage = value; } 
        }

        /// <summary>
        /// 设置或获取当前播放进度条右边背景图片
        /// </summary>
        public Image RightBackImage 
        {
            get { return picBoxRight.BackgroundImage; }
            set { picBoxRight.BackgroundImage = value; } 
        }

        /// <summary>
        /// 设置或获取当前播放进度条中间背景图片
        /// </summary>
        public Image MiddleBackImage 
        {
            get { return picBoxMiddle.BackgroundImage; }
            set { picBoxMiddle.BackgroundImage = value; } 
        }
        public UserControl1()
        {
            InitializeComponent();

            picBoxLeft.Size = new Size(8, 10);  //左边
            picBoxRight.Size = new Size(8, 10); //右边
            picBoxMiddle.Size = new Size(0, 10); //中间

            picBoxLeft.Dock = DockStyle.Left;
            picBoxRight.Dock = DockStyle.Right;
            picBoxMiddle.Width = this.Width - 16;
            picBoxMiddle.Location = new Point(8, 0);

            this.BackColor = Color.Transparent;
            picBoxLeft.BackColor = Color.Transparent;
            picBoxRight.BackColor = Color.Transparent;
            picBoxMiddle.BackColor = Color.Transparent;

            picBoxLeft.BackgroundImage = LeftBackImage;
            picBoxRight.BackgroundImage = RightBackImage;
            picBoxMiddle.BackgroundImage = MiddleBackImage;
        }

        private void UserControl1_SizeChanged(object sender, EventArgs e)
        {
            this.Size = new Size(UCTime, 10);
            picBoxMiddle.Width = this.Width - 16;
        }
    }
}
